#include "sim_ext.h"
#include "hash.h"
static HASH *name_hash_table;

Name(element,name)
Element	*element;
char 		*name;
{
    if(element == NULL || name == NULL ||strlen(name) == 0) {
	return(0);
    }
    /*
    ** assign the name 
    */
    element->name = (char *)malloc(strlen(name)+1);
    strcpy(element->name,name);
    return(1);
}

/*
** Hash table utilities
*/
void NameHashInit()
{
HASH *hash_create();

    /*
    ** create the table
    */
    name_hash_table = hash_create(2000);
}

int AddName(name)
char *name;
{
ENTRY	item,*hash_enter();

    item.data = name;
    item.key = name;
    /*
    ** put the name into the table
    */
    if(hash_enter(&item,name_hash_table) == NULL){
	Error();
	printf("name hash table full\n");
	return(0);
    };
    return(1);
}

int FindName(key)
char	*key;
{
ENTRY	*found_item,*hash_find();

    /*
    ** get the name from the table
    */
    if((found_item = hash_find(key,name_hash_table)) != NULL){
	return(1);
    } else
	return(0);
}

